﻿var doc = app.documents[0] ;

var mySelName = "";
try{mySelName= doc.selection[0].constructor.name;}catch(e){}    //選択中のconstructor.nameを取得
if(mySelName == "InsertionPoint"|mySelName == "Text"|mySelName == "Character"){ //確認

//ダイアログ表示
var dlg = app.dialogs.add( {name:"脚注／文末脚注を生成"} );
	with(dlg){
		with(dialogColumns.add() ){
			var bp1 = borderPanels.add();
			with(bp1) {
				with(dialogColumns.add() ){
					with(dialogRows.add()){
						staticTexts.add({staticLabel:"作業内容を選択", minWidth:10 });
					}
					with(dialogRows.add()){
						var myWork = dropdowns.add({stringList: ['A：〔◆◆◇◇〕も〔★★☆☆〕も脚注にする', 'B：〔◆◆◇◇〕も〔★★☆☆〕も文末脚注にする', 'C：〔◆◆◇◇〕は脚注／〔★★☆☆〕は文末脚注にする'], selectedIndex:0, minWidth:360});
					}
		
				}
			}
        }        
	}		
//	}
flag =dlg.show();
if(flag){
//共通でやること

//検索オプションGrep
app.changeGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences = NothingEnum.nothing;
app.findChangeGrepOptions.includeHiddenLayers = true;//非表示レイヤーを含めるかどうか
app.findChangeGrepOptions.includeMasterPages = true;//マスターページを含めるかどうか
app.findChangeGrepOptions.includeFootnotes = true;//脚注を含めるかどうか

/////////表組み内の脚注・文末脚注を表の直後に出す。/////////
var myStory = doc.selection[0].parentStory;
for(i=0;myStory.tables.length>i;i++){  //01
    app.findGrepPreferences.findWhat="〔[◆★][◆★][\\s\\S]+?[◇☆][◇☆]〕"
    var gr=myStory.tables[i].findGrep(); // 検索
    var grl=gr.length; 
    //表の中の脚注を1つにまとめる
    var myContents ="";
    for (j=0; j<grl; j++) { //02
        myContents =  myContents + "◎" +gr[j].contents + "\r" ;
        //表内の文章は削除して【◆◆0◇◇】【★★0☆☆】の体裁に
        gr[j].contents=gr[j].contents.replace(/〔◆◆/g,"【◆◆"); 
        gr[j].contents=gr[j].contents.replace(/〓[\s\S]+◇◇〕/g,"◇◇】"); 
        gr[j].contents=gr[j].contents.replace(/〔★★/g,"【★★"); 
        gr[j].contents=gr[j].contents.replace(/〓[\s\S]+☆☆〕/g,"☆☆】"); 
        }   //02
    
    //表の直後にmyContentsを挿入
    //alert(myStory.tables[i].storyOffset.index)
    var tableIndex = myStory.tables[i].storyOffset.index;
    var noteCsr = myStory.insertionPoints[tableIndex+2];
    noteCsr.contents = myContents;
    }	//01

//それぞれの作業
    if(myWork.selectedIndex==0){    //A：〔◆◆◇◇〕も〔★★☆☆〕も脚注にする
        //alert('A：〔◆◆◇◇〕も〔★★☆☆〕も脚注にする……です')
        
        //記号を統一
        app.findGrepPreferences.findWhat="〔★★"
        app.changeGrepPreferences.changeTo = "〔◆◆";
        myStory.changeGrep();
        app.findGrepPreferences.findWhat="☆☆〕"
        app.changeGrepPreferences.changeTo = "◇◇〕";
        myStory.changeGrep();

        //対象箇所を検索
        app.findGrepPreferences.findWhat="〔◆◆[\\s\\S]+?◇◇〕"
        var gr=myStory.findGrep(); // 検索
        var grl=gr.length; 

        //脚注を生成
        for (i=0; i<grl; i++) { 
            var ftContents = gr[i].contents;
            var cursor=gr[i].characters[i];
            var ftMaker=cursor.footnotes.add();
            ftNum = ftMaker.index+1;
            ftMaker.contents=ftNum+"\t"+ftContents;
        }

        }else if(myWork.selectedIndex==1){  //B：〔◆◆◇◇〕も〔★★☆☆〕も文末脚注にする
            //alert('B：〔◆◆◇◇〕も〔★★☆☆〕も文末脚注にする……です')
            
            //記号を統一
            app.findGrepPreferences.findWhat="〔◆◆"
            app.changeGrepPreferences.changeTo = "〔★★";
            myStory.changeGrep();
            app.findGrepPreferences.findWhat="◇◇〕"
            app.changeGrepPreferences.changeTo = "☆☆〕";
            myStory.changeGrep();
            
            //対象箇所を検索
            app.findGrepPreferences.findWhat="〔★★[\\s\\S]+?☆☆〕"
            var gr=myStory.findGrep(); // 検索
            var grl=gr.length; 
            
            //文末脚注を生成
            for (i=0; i<grl; i++) { 
                var ftContents = gr[i].contents;
                var cursor=gr[i].characters[i];
                var csr = cursor.insertionPoints[-1];
                csr.createEndnote();
                myStory.endnotes[i].texts[0].insertionPoints[-1].contents=ftContents;
                }
            
            }else if(myWork.selectedIndex==2){  //C：〔◆◆◇◇〕は脚注／〔★★☆☆〕は文末脚注にする
                //alert('C：〔◆◆◇◇〕は脚注／〔★★☆☆〕は文末脚注にする……です')

                //脚注対象箇所を検索
                app.findGrepPreferences.findWhat="〔◆◆[\\s\\S]+?◇◇〕"
                var gr=myStory.findGrep(); // 検索
                var grl=gr.length; 

                //脚注を生成
                for (i=0; i<grl; i++) {
                    var ftContents = gr[i].contents;
                    var cursor=gr[i].characters[i];
                    var ftMaker=cursor.footnotes.add();
                    ftNum = ftMaker.index+1;
                    ftMaker.contents=ftNum+"\t"+ftContents;
                    }
                
                //文末脚注対象箇所を検索
                app.findGrepPreferences.findWhat="〔★★[\\s\\S]+?☆☆〕"
                var gr=myStory.findGrep(); // 検索
                var grl=gr.length; 

                //文末脚注を生成
                for (i=0; i<grl; i++) {
                    var ftContents = gr[i].contents;
                    var cursor=gr[i].characters[i];
                    var csr = cursor.insertionPoints[-1];
                    csr.createEndnote();
                    myStory.endnotes[i].texts[0].insertionPoints[-1].contents=ftContents;
                    } 
                }
            
            //不要な記号などを削除
            app.findGrepPreferences.findWhat="(?<!〔)[★◆][★◆][\\s\\S]+?[☆◇][☆◇]〕"
            app.changeGrepPreferences.changeTo = "";
            app.changeGrep();
            app.findGrepPreferences.findWhat="〔(?=~F)"
            app.changeGrepPreferences.changeTo = "●●●●●";
            app.changeGrep();
            app.findGrepPreferences.findWhat="●{5,}"
            app.changeGrepPreferences.changeTo = "";
            app.changeGrep();
            app.findGrepPreferences.findWhat="[☆◇][☆◇]〕"
            app.changeGrepPreferences.changeTo = "";
            app.changeGrep();
            app.findGrepPreferences.findWhat="〔[★◆][★◆]\\d+〓"
            app.changeGrepPreferences.changeTo = "";
            app.changeGrep();
            
            //検索欄・置換欄をクリア
            app.changeGrepPreferences.changeTo = "";
            app.findGrepPreferences.findWhat=""
            }
        }else{
            alert("ストーリーを選択してから実行してください\r（一部の文字を選択 or カーソル点滅でOK）")
            }